/* DICElib (DIstributed CAVE Engine library) 
 * Copyright (c) 2001 Bruno Barberi Gnecco <brunobg@lsi.usp.br>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to
 * deal in the Software without restriction, including without limitation the
 * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies of the Software, its documentation and marketing & publicity
 * materials, and acknowledgment shall be given in the documentation, materials
 * and software packages that this Software was used.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#include "_dicelib.h"
#include <ctype.h>
#include <string.h>

void *(*func_list) (void *data);

#ifdef FUTURE
#define FUNCTION		"dice_function_init"
int dice_function_init ( char *functions ) {
	DICE_Function 		*f = DICE_MyFunctions;
	char			*p;
	int			num;

	/* count the number of functions */
	p = functions;
	while (*p) {
		while (isspace(*p))
			p++;
		while (isalpha(*p) || *p == '_')
			p++;
		num++;
	}

	/* allocate memory */
	func_list = malloc(num*sizeof(void (*)));
	/* open the functions */
	while (f->name) {
		if (!strcmp(f->name, functions))
			break;
		f++;
	}
	if (!f->name) {
		_dice_debug(2, dice_printf(FUNCTION, 
				"Warning: couldn't load function \"%s\"\n",
				functions);)
	}
	else
		dice_data.functions = f->func;

	return 0;
}

int DICE_function ( int num, ... ) {
	
	if ( dice_data.function )
		return dice_data.function(data);
	return -1;
}
#endif
