#include "dicelib.h"
#include "_dicelib.h"

DICE_no_functions;

void *float3_unpack	( char *data, int *n );

char *float3_pack	( void *data, int *n ) {
	char			*buf, *t;
	float			*vec;
	int			m;

	vec = (float *)data;
	buf = (char *)malloc(3*4); /* three floats */
	if ( !buf )
		return NULL;
	t = DICE_type_pack("float", (void *)&vec[0], &m);
	memcpy(buf, t, 4);
	free(t);
	t = DICE_type_pack("float", (void *)&vec[1], &m);
	memcpy(buf+4, t, 4);
	free(t);
	t = DICE_type_pack("float", (void *)&vec[2], &m);
	memcpy(buf+8, t, 4);
	free(t);
	*n = 12;
	return buf;
}
void *float3_unpack	( char *data, int *n ) {
	float			*vec, *f;
	int			m;
	
	vec = (float *)malloc(3*sizeof(float)); /* three floats */
	if ( !vec )
		return NULL;
	f = (float *)DICE_type_unpack("float", data, &m);
	vec[0] = *f;
	free(f);
	f = (float *)DICE_type_unpack("float", data+4, &m);
	vec[1] = *f;
	free(f);
	f = (float *)DICE_type_unpack("float", data+8, &m);
	vec[2] = *f;
	free(f);
	*n = 12;
	return (void *)vec;
}

void float3_free		( void *data ) {
	if ( data )
		free(data);
}

DICE_Type DICE_MyTypes[] = {
	{ "float3", float3_pack, float3_unpack, float3_free },
	{ NULL, NULL, NULL, NULL }
};

int main(int argc, char *argv[]) {
	unsigned long		*d, *e;
	float			f = 1.2, *g;
	char			str[] = "Hello World!", *p;
	float			vec[3] = { 1.2, 1.3, 1.4 }, *v;


	d = (unsigned long *)malloc(sizeof(unsigned long));
	if (!d)
		exit(1);
	*d = 17;

	DICE_init(&argc, argv);

	DICE_sync_new("int", "signed_long", d);
	DICE_sync_new("ourstring", "string", str);
	DICE_sync_new("ourfloat", "float", &f);
	DICE_sync_new("floatvec", "float3", vec);

	DICE_sync();

	*d = 129;
	DICE_sync_update("int", d);

	DICE_sync();
	d = DICE_sync_get("int");
	p = DICE_sync_get("ourstring");
	g = DICE_sync_get("ourfloat");
	v = DICE_sync_get("floatvec");

	printf("int is %d, string is %s, float is %f\n", *d, p, *g);
	printf("floats are { %f %f %f}\n", v[0], v[1], v[2]);

	DICE_close();
	return 0;
}
